
'*************************************************************************************************
'Notes: I got these definitions to work with the registry from a website about ten years ago.
'       If you know the original author, please notify me so I can put his name here.
'*************************************************************************************************

Option Strict Off
Option Explicit On
Module Module2
	Public Const gsSLASH_BACKWARD As String = "\"
	
	''Registry API Declarations...
	Public Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Integer) As Integer
	Public Declare Function RegCreateKeyEx Lib "advapi32"  Alias "RegCreateKeyExA"(ByVal hKey As Integer, ByVal lpSubKey As String, ByVal Reserved As Integer, ByVal lpClass As String, ByVal dwOptions As Integer, ByVal samDesired As Integer, ByRef lpSecurityAttributes As SECURITY_ATTRIBUTES, ByRef phkResult As Integer, ByRef lpdwDisposition As Integer) As Integer
	Public Declare Function RegDeleteKey Lib "advapi32"  Alias "RegDeleteKeyA"(ByVal hKey As Integer, ByVal lpSubKey As String) As Integer
	Public Declare Function RegOpenKeyEx Lib "advapi32"  Alias "RegOpenKeyExA"(ByVal hKey As Integer, ByVal lpSubKey As String, ByVal ulOptions As Integer, ByVal samDesired As Integer, ByRef phkResult As Integer) As Integer
	Public Declare Function RegQueryValueEx Lib "advapi32"  Alias "RegQueryValueExA"(ByVal hKey As Integer, ByVal lpValueName As String, ByVal lpReserved As Integer, ByRef lpType As Integer, ByVal lpData As String, ByRef lpcbData As Integer) As Integer
	Public Declare Function RegSetValueEx Lib "advapi32"  Alias "RegSetValueExA"(ByVal hKey As Integer, ByVal lpValueName As String, ByVal Reserved As Integer, ByVal dwType As Integer, ByVal lpData As String, ByVal cbData As Integer) As Integer
	Public Declare Function RegEnumValue Lib "advapi32"  Alias "RegEnumValueA"(ByVal hKey As Integer, ByVal dwIndex As Integer, ByVal lpValueName As String, ByRef lpcbValueName As Integer, ByVal lpReserved As Integer, ByRef lpType As Integer, ByVal lpData As String, ByRef lpcbData As Integer) As Integer
	Public Declare Function RegEnumKeyEx Lib "advapi32.dll"  Alias "RegEnumKeyExA"(ByVal hKey As Integer, ByVal dwIndex As Integer, ByVal lpName As String, ByRef lpcbName As Integer, ByVal lpReserved As Integer, ByVal lpClass As Integer, ByVal lpcbClass As Integer, ByRef lpftLastWriteTime As FileTime) As Integer
	
	''Reg Data Types...
	Public Const REG_NONE As Short = 0 ' No value type
	Public Const REG_SZ As Short = 1 ' Unicode nul terminated string
	Public Const REG_EXPAND_SZ As Short = 2 ' Unicode nul terminated string
	Public Const REG_BINARY As Short = 3 ' Free form binary
	Public Const REG_DWORD As Short = 4 ' 32-bit number
	Public Const REG_DWORD_LITTLE_ENDIAN As Short = 4 ' 32-bit number (same as REG_DWORD)
	Public Const REG_DWORD_BIG_ENDIAN As Short = 5 ' 32-bit number
	Public Const REG_LINK As Short = 6 ' Symbolic Link (unicode)
	Public Const REG_MULTI_SZ As Short = 7 ' Multiple Unicode strings
	Public Const REG_RESOURCE_LIST As Short = 8 ' Resource list in the resource map
	Public Const REG_FULL_RESOURCE_DESCRIPTOR As Short = 9 ' Resource list in the hardware description
	Public Const REG_RESOURCE_REQUIREMENTS_LIST As Short = 10
	
	''Reg Create Type Values...
	Public Const REG_OPTION_RESERVED As Short = 0 ' Parameter is reserved
	Public Const REG_OPTION_NON_VOLATILE As Short = 0 ' Key is preserved when system is rebooted
	Public Const REG_OPTION_VOLATILE As Short = 1 ' Key is not preserved when system is rebooted
	Public Const REG_OPTION_CREATE_LINK As Short = 2 ' Created key is a symbolic link
	Public Const REG_OPTION_BACKUP_RESTORE As Short = 4 ' open for backup or restore
	
	''Reg Key Security Options...
	Public Const READ_CONTROL As Integer = &H20000
	Public Const KEY_QUERY_VALUE As Integer = &H1
	Public Const KEY_SET_VALUE As Integer = &H2
	Public Const KEY_CREATE_SUB_KEY As Integer = &H4
	Public Const KEY_ENUMERATE_SUB_KEYS As Integer = &H8
	Public Const KEY_NOTIFY As Integer = &H10
	Public Const KEY_CREATE_LINK As Integer = &H20
	Public Const KEY_READ As Double = KEY_QUERY_VALUE + KEY_ENUMERATE_SUB_KEYS + KEY_NOTIFY + READ_CONTROL
	Public Const KEY_WRITE As Single = KEY_SET_VALUE + KEY_CREATE_SUB_KEY + READ_CONTROL
	Public Const KEY_EXECUTE As Integer = KEY_READ
	Public Const KEY_ALL_ACCESS As Double = KEY_QUERY_VALUE + KEY_SET_VALUE + KEY_CREATE_SUB_KEY + KEY_ENUMERATE_SUB_KEYS + KEY_NOTIFY + KEY_CREATE_LINK + READ_CONTROL
	
	''Return Value...
	Public Const ERROR_SUCCESS As Short = 0
	Public Const ERROR_ACCESS_DENIED As Short = 5
	Public Const ERROR_NO_MORE_ITEMS As Short = 259
	
	''Hierarchy separator
	Public Const KeySeparator As String = "\"
	
	''Registry Security Attributes TYPE...
	Public Structure SECURITY_ATTRIBUTES
		Dim nLength As Integer
		Dim lpSecurityDescriptor As Integer
		Dim bInheritHandle As Boolean
	End Structure
	Public Structure FileTime
		Dim dwLowDateTime As Integer
		Dim dwHighDateTime As Integer
	End Structure
	
	''Reg Key ROOT Types...
	Public Enum REGToolRootTypes
		HKEY_CLASSES_ROOT = &H80000000
		HKEY_CURRENT_USER = &H80000001
		HKEY_LOCAL_MACHINE = &H80000002
		HKEY_USERS = &H80000003
		HKEY_PERFORMANCE_DATA = &H80000004
		HKEY_CURRENT_CONFIG = &H80000005
		HKEY_DYN_DATA = &H80000006
	End Enum
	
	Public Function GetKeyValue(ByVal KeyRoot As REGToolRootTypes, ByRef KeyName As String, ByRef ValueName As String) As String
		Dim i As Integer ' Loop Counter
		Dim hKey As Integer ' Handle To An Open Registry Key
		Dim KeyValType As Integer ' Data Type Of A Registry Key
		Dim sTmp As String ' Tempory Storage For A Registry Key Value
		Dim sReturn As String
		Dim KeyValSize As Integer ' Size Of Registry Key Variable
		Dim sByte_Renamed As String
		
		If ValidKeyName(KeyName) Then
			On Error GoTo LocalErr
			
			' Open registry key under KeyRoot
			Attempt(RegOpenKeyEx(KeyRoot, KeyName, 0, KEY_ALL_ACCESS, hKey))
			
			sTmp = New String(Chr(0), 1024) ' Allocate Variable Space
			KeyValSize = 1024 ' Mark Variable Size
			
			' Retrieve Registry Key Value...
			Attempt(RegQueryValueEx(hKey, ValueName, 0, KeyValType, sTmp, KeyValSize)) ' Get/Create Key Value
			
			If (Asc(Mid(sTmp, KeyValSize, 1)) = 0) Then ' Win95 Adds Null Terminated String...
				sTmp = Left(sTmp, KeyValSize - 1) ' Null Found, Extract From String
			Else ' WinNT Does NOT Null Terminate String...
				sTmp = Left(sTmp, KeyValSize) ' Null Not Found, Extract String Only
			End If
			
			' Determine Key Value Type For Conversion...
			Select Case KeyValType ' Search Data Types...
				Case REG_SZ ' String Registry Key Data Type
					sReturn = sTmp '(Do nothing)
				Case REG_MULTI_SZ ' String Registry Key Data Type
					sReturn = sTmp '(Do nothing)
				Case REG_DWORD ' Double Word Registry Key Data Type
					For i = Len(sTmp) To 1 Step -1 ' Convert Each Bit
						sByte_Renamed = Hex(Asc(Mid(sTmp, i, 1)))
						Do Until Len(sByte_Renamed) = 2
							sByte_Renamed = "0" & sByte_Renamed
						Loop 
						sReturn = sReturn & sByte_Renamed ' Build Value Char. By Char.
					Next 
					sReturn = VB6.Format("&h" & sReturn) ' Convert Double Word To String
			End Select
			
			GetKeyValue = sReturn
			
LocalErr: 
			On Error Resume Next
			RegCloseKey(hKey)
		End If
	End Function
	
	Private Sub Attempt(ByRef rc As Integer)
		If (rc <> ERROR_SUCCESS) Then
			Err.Raise(5)
		End If
	End Sub
	
	Private Function ValidKeyName(ByRef KeyName As String) As Boolean
		'A key name is invalid if it begins or ends with \ or contains \\
		If Left(KeyName, 1) <> gsSLASH_BACKWARD Then
			If Right(KeyName, 1) <> gsSLASH_BACKWARD Then
				If InStr(KeyName, gsSLASH_BACKWARD & gsSLASH_BACKWARD) = 0 Then
					ValidKeyName = True
				End If
			End If
		End If
	End Function
	
	Function RegSetStringValue(ByVal hKey As Integer, ByVal strValueName As String, ByVal strData As String, ByRef Score As Boolean) As Boolean
		Dim lResult As Integer
		Dim strHkey As String
		
		On Error GoTo 0
		
		If Score Then
            lResult = RegSetValueEx(hKey, strValueName, 0, REG_SZ, strData, Len(strData) + 1)
		Else
           lResult = RegSetValueEx(hKey, strValueName, 0, REG_MULTI_SZ, strData, Len(strData) + 1)
		End If
	End Function
End Module